com.fasterxml.jackson.databind.node

## Class MissingNode

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializable.Base
  - - com.fasterxml.jackson.databind.JsonNode
    - - com.fasterxml.jackson.databind.node.BaseJsonNode
      - - com.fasterxml.jackson.databind.node.ValueNode
        - - com.fasterxml.jackson.databind.node.MissingNode

- All Implemented Interfaces:
    TreeNode, JsonSerializable, Iterable<JsonNode>

      public final class MissingNode
      extends ValueNode

  This singleton node class is generated to denote "missing nodes" along paths that do not exist. For example, if a path via element of an array is requested for an element outside range of elements in the array; or for a non-array value, result will be reference to this node.

  In most respects this placeholder node will act as `NullNode`; for example, for purposes of value conversions, value is considered to be null and represented as value zero when used for numeric conversions.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `asText()` Method that will return a valid String representation of the container value, if the node is a value node (method `JsonNode.isValueNode()` returns true), otherwise empty String.
    `String` | `asText(String defaultValue)` Method similar to `JsonNode.asText()`, except that it will return `defaultValue` in cases where null value would be returned; either for missing nodes (trying to access missing property, or element at invalid item for array) or explicit nulls.
    `JsonToken` | `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
    `<T extends JsonNode> T` | `deepCopy()` All current value nodes are immutable, so we can just return them as is.
    `boolean` | `equals(Object o)` Equality for node objects is defined as full (deep) value equality.
    `static MissingNode` | `getInstance()`
    `JsonNodeType` | `getNodeType()` Return the type of this node
    `int` | `hashCode()`
    `void` | `serialize(JsonGenerator jg, SerializerProvider provider)` Method called to serialize node instances using given generator.
    `void` | `serializeWithType(JsonGenerator g, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
    `String` | `toString()` Method that will produce developer-readable representation of the node; which may or may not be as valid JSON.

    - ### Methods inherited from class com.fasterxml.jackson.databind.node.ValueNode

      `_at, findParent, findParents, findValue, findValues, findValuesAsText, get, get, has, has, hasNonNull, hasNonNull, path, path`

    - ### Methods inherited from class com.fasterxml.jackson.databind.node.BaseJsonNode

      `findPath, numberType, traverse, traverse`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonNode

      `asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, at, at, bigIntegerValue, binaryValue, booleanValue, canConvertToInt, canConvertToLong, decimalValue, doubleValue, elements, equals, fieldNames, fields, findParents, findValues, findValuesAsText, floatValue, intValue, isArray, isBigDecimal, isBigInteger, isBinary, isBoolean, isContainerNode, isDouble, isFloat, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isObject, isPojo, isShort, isTextual, isValueNode, iterator, longValue, numberValue, shortValue, size, textValue, with, withArray`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializable.Base

      `isEmpty`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### deepCopy

          public <T extends JsonNode> T deepCopy()

      Description copied from class: `ValueNode`
      All current value nodes are immutable, so we can just return them as is.
      Overrides:
        `deepCopy` in class `ValueNode`
      Returns:
        Node that is either a copy of this node (and all non-leaf children); or, for immutable leaf nodes, node itself.

    - #### getInstance

          public static MissingNode getInstance()

    - #### getNodeType

          public JsonNodeType getNodeType()

      Description copied from class: `JsonNode`
      Return the type of this node
      Specified by:
        `getNodeType` in class `JsonNode`
      Returns:
        the node type as a `JsonNodeType` enum value

    - #### asToken

          public JsonToken asToken()

      Description copied from class: `BaseJsonNode`
      Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)
      Specified by:
        `asToken` in interface `TreeNode`
      Specified by:
        `asToken` in class `ValueNode`

    - #### asText

          public String asText()

      Description copied from class: `JsonNode`
      Method that will return a valid String representation of the container value, if the node is a value node (method `JsonNode.isValueNode()` returns true), otherwise empty String.
      Specified by:
        `asText` in class `JsonNode`

    - #### asText

          public String asText(String defaultValue)

      Description copied from class: `JsonNode`
      Method similar to `JsonNode.asText()`, except that it will return `defaultValue` in cases where null value would be returned; either for missing nodes (trying to access missing property, or element at invalid item for array) or explicit nulls.
      Overrides:
        `asText` in class `JsonNode`

    - #### serialize

          public final void serialize(JsonGenerator jg,
                       SerializerProvider provider)
                               throws IOException,
                                      JsonProcessingException

      Description copied from class: `BaseJsonNode`
      Method called to serialize node instances using given generator.
      Specified by:
        `serialize` in interface `JsonSerializable`
      Specified by:
        `serialize` in class `BaseJsonNode`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### serializeWithType

          public void serializeWithType(JsonGenerator g,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws IOException,
                                        JsonProcessingException

      Description copied from class: `BaseJsonNode`
      Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
      Specified by:
        `serializeWithType` in interface `JsonSerializable`
      Overrides:
        `serializeWithType` in class `ValueNode`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### equals

          public boolean equals(Object o)

      Description copied from class: `JsonNode`
      Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

      Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

      Specified by:
        `equals` in class `JsonNode`

    - #### toString

          public String toString()

      Description copied from class: `JsonNode`
      Method that will produce developer-readable representation of the node; which may or may not be as valid JSON. If you want valid JSON output (or output formatted using one of other Jackson supported data formats) make sure to use `ObjectMapper` or `ObjectWriter` to serialize an instance, for example:

             String json = objectMapper.writeValueAsString(rootNode);

      Note: method defined as abstract to ensure all implementation classes explicitly implement method, instead of relying on `Object.toString()` definition.

      Overrides:
        `toString` in class `ValueNode`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `BaseJsonNode`

Copyright © 2008–2016 FasterXML. All rights reserved.